<?php 

/**
 Remote Control Setup Controller
 
 @Copyright 2016 Stefan Rick
 @author Stefan Rick
 Mail: stefan@rick-software.de
 Web: http://www.netzberater.de

 */

/**
 * 
 * @author Stefan Rick
 *
 */
class RemoteControl extends Service {
		
	public $viewname = 'Remote Control';	
	public $scriptPath = '';	
	
	public function __construct(){
		parent::__construct();
		$this->scriptPath = dirname(__FILE__).'/../scripts/';		
		//Set your Pluginname
		$this->pluginname = _('Remote Control');
		$this->registerLocale(dirname(__FILE__).'/../locale', 'remotecontrol');		
		
		//if($this->checkLicense(true) == false)
		//	return true;
		
		$this->view->shellinabox = array();
		
		if($_REQUEST['ajax'] == 1 && $_REQUEST['action'] == 'install_shellinabox'){
			//Function to get Progress of Installation
			$this->_install_shellinabox(1);
			ob_end_clean();
			echo implode('<br />', $this->view->message);
			ob_flush();
			die();
		}
		
		$this->_checkinstall();
		
		if(isset($_REQUEST['action'])){
			if($_REQUEST['action'] == 'install_shellinabox'){
				$this->_install_shellinabox();
			}
			
			if($_REQUEST['action'] == 'uninstall_shellinabox'){
				$this->_uninstall_shellinabox();
			}
						
			if($_REQUEST['action'] == 'save'){
				$this->selectAutostart(isset($_REQUEST['shellinabox_autostart']) ? 1 : 0, false, 'shellinabox');								
			}
		}		
		if($this->view->installed){
			//Get Debug Info						
			$this->view->shellinabox['autostart'] = $this->checkAutostart('shellinabox', false);
		}
		
		$this->_getAllLogs();
		$this->showHelpSidebar();
	}
		
	private function _checkinstall(){		
		$this->view->shellinabox['running'] = shell_exec('ps -Al | grep shellinabox');
		$this->view->shellinabox['installed'] = shell_exec("dpkg -s shellinabox | grep Status | grep 'install ok' | wc -l");
		return true;
	}		
	
	private function _install_shellinabox($ajax = 0){		
		if($ajax == 0){
			ignore_user_abort(true);
			set_time_limit(3600);
			$this->view->message[] = _t('Shellinabox install started');	
			if($this->getProgressWithAjax('/opt/max2play/cache/install_shellinabox.txt', 1, 1)){
				$shellanswer = $this->writeDynamicScript(array($this->scriptPath."install_shellinabox.sh >> /opt/max2play/cache/install_shellinabox.txt &"), false, true);
			}
		}else{
			//Get only last 20 Lines
			$status = $this->getProgressWithAjax('/opt/max2play/cache/install_shellinabox.txt',0, 0, 20);
			$this->view->message[] = nl2br($status);
			if(strpos($status, 'Finished') !== FALSE){
				shell_exec('rm /opt/max2play/cache/install_shellinabox.txt');
				$this->selectAutostart(1);
			}
		}
		return true;
	}		
	
	private function _uninstall_shellinabox(){
		$this->view->message[] = _t('Shellinabox uninstall started');		
		$script[] = 'echo "Y" | apt-get purge shellinabox -y';
		$this->view->message[] = $this->formatMessageOutput($this->writeDynamicScript($script));
		return true;
	}
	
	/**
	 * get some Debug Output and save it for view
	 */
	private function _getAllLogs(){		
		$out = array();
		
		$out['Shell in a box'] = $this->view->shellinabox['running'];		
		$this->view->debug = $out;
	}
	
	public function showHelpSidebar(){
		global $helpSidebar;
		$helpSidebar['title'] = _t('Help - Remote Control');
		$helpSidebar['content'] = _t('<ul><li>Install ShellInABox and use a Shell from your Browser.</li><li>Access your Device from anywhere with Max2Play Remote Service</li></ul>');
		return true;
	}
}

$rc = new RemoteControl();

//This Line includes the View-Script -> it should have the same name as your class
include_once(dirname(__FILE__).'/../view/setup.php');

